/*
 * File:   Date.h
 * Author: Joe
 *
 * Created on February 17, 2011, 6:35 AM
 */

#ifndef _DATE_H
#define	_DATE_H

#include <string>
#include <ctime>
#include <iostream>
#include <utility>

class Date
{
public:
   Date(time_t = time(0));
   Date(const std::string& date);
   Date(const Date& orig) = default;
   time_t get_value() const { return value; }
   virtual ~Date();
   bool operator<(const Date&) const;
   bool operator>(const Date&) const;
   bool operator>=(const Date&) const;
   bool operator<=(const Date&) const;
   bool operator==(const Date&) const;
   Date& operator=(std::string);
   bool operator!=(const Date&) const;
   Date operator+(int) const;  // add days to a Date
   Date& operator++();  // prefix increment operator
   Date operator++(int);  // postfix increment operator
   Date& operator--();  // prefix decrement operator
   Date operator--(int);  // postfix decrement operator
   time_t operator-(const Date&) const;
   int month() const;
   int dayOfMonth() const;

private:
	time_t  value;
   friend std::ostream& operator<<(std::ostream& out, const Date& dt);
};


unsigned short get2Byte_unsigned_short_From_string_at_pos(const std::string& S, size_t pos);
int get_intFrom_stringAtPos(const std::string& S, size_t pos, size_t length = 2);


#endif	/* _DATE_H */

