// Assignment 6 solution - Winter 2021
#include <iomanip>
#include <iostream>
#include <iterator>
#include <string>
#include <fstream>
#include <cstdlib>
#include <unordered_set>
using namespace std;

#include "Date.h"
#include "mutualfund.h"

const int NumberOfComparisons = 100;
void shuffleNavHistoryFile(const string& ticker);
void analyze2Funds(const MutualFund& fund1,const MutualFund& fund2);

int main()
{
       // Part 1
    string ticker1 = "VFIAX", ticker2 = "VTSAX";
    shuffleNavHistoryFile(ticker1);
    shuffleNavHistoryFile(ticker2);

    // Part 2
    MutualFund vfiax(ticker1);
    MutualFund vtsax(ticker2);
    vfiax.report();
    vtsax.report();

    // Part 3
    analyze2Funds(vfiax, vtsax);
}

void analyze2Funds(const MutualFund& fund1,const MutualFund& fund2)
{
    Date buyDate, sellDate;
    Date startDate, endDate;
    float value1, value2;
    float avgGain1 = 0;
    float avgGain2 = 0;
    cout << fixed << setprecision(2);
    cout << "  Buy Date    Sell Date " << fund1.getTicker() << " Value  " << fund1.getTicker()
            << " Gain " << fund2.getTicker() << " Value  " << fund2.getTicker() << " Gain "
            << fund1.getTicker() << "-" << fund2.getTicker() << endl;

   for (auto i = 0; i < NumberOfComparisons; i++)
   {
       auto pairIt = fund1.getTwoRandomNavs();

        buyDate = pairIt.first->first;
        sellDate = pairIt.second->first;

        value1 = fund1.getReturnOverTime(MutualFund::InitialInvestment, buyDate, sellDate);
        value2 = fund2.getReturnOverTime(MutualFund::InitialInvestment, buyDate, sellDate);
        avgGain1 += value1 - MutualFund::InitialInvestment;
        avgGain2 += value2 - MutualFund::InitialInvestment;
        cout << buyDate << "   " << sellDate
                << setw(12) << value1
                << setw(12) << value1 - MutualFund::InitialInvestment
                << setw(12) << value2
                << setw(12) << value2 - MutualFund::InitialInvestment
                << setw(12) << value1 - value2 << endl;
    }
    avgGain1 /= NumberOfComparisons;
    avgGain2 /= NumberOfComparisons;
    cout << "\nAverage gain for " << fund1.getTicker() << " = " << avgGain1 << endl;
    cout << "Average gain for " << fund2.getTicker() << " = " << avgGain2 << endl;

}

void shuffleNavHistoryFile(const string& ticker)
{
    string filename = Path + ticker + ".csv";
    ifstream hisFin(filename);
    if (!hisFin)
    {
        cerr << "Unable to open history file: " << filename << endl;
        exit(1);
    }

    cout << "Reading " << filename << " into an unordered_set<string> ... ";

    string buffer;
    unordered_set<string> data;
    getline(hisFin, buffer); // skip first line
    while (getline(hisFin, buffer))
    {
        data.insert(buffer);
    }
    cout << "\nInput data stored in " << data.bucket_count() << " buckets" << endl;

    filename = Path + ticker + "shuffled.csv";

    ofstream fout(filename);
    if (!fout)
    {
        cerr << "Unable to open output file " << filename << "\nExiting ... " << endl;
        exit(EXIT_FAILURE);
    }
    cout << "Writing unordered_set<string> data into file " << filename << endl << endl;

    ostream_iterator<string> foutIt(fout, "\n");
    copy(data.cbegin(), data.cend(), foutIt);
}
